// Downloaded from https://repo.progsbase.com - Code Developed Using progsbase.

function ReadXbytes(data, position, lengthx){
  var r;
  var i;

  r = CreateByteArray(lengthx);

  for(i = 0; i < lengthx; i = i + 1){
    r.bytes[i] = ReadByte(data, position);
  }

  return r;
}
function Read4bytesBE(data, position){
  var r;

  r = 0;
  r = r + Math.pow(2, 24)*ReadByte(data, position);
  r = r + Math.pow(2, 16)*ReadByte(data, position);
  r = r + Math.pow(2, 8)*ReadByte(data, position);
  r = r + ReadByte(data, position);

  return r;
}
function Read2bytesBE(data, position){
  var r;

  r = 0;
  r = r + Math.pow(2, 8)*ReadByte(data, position);
  r = r + ReadByte(data, position);

  return r;
}
function ReadByte(data, position){
  var next;

  next = data.bytes[position.numberValue];
  position.numberValue = position.numberValue + 1;

  return next;
}
function Read4bytesLE(data, position){
  var r;

  r = 0;
  r = r + ReadByte(data, position);
  r = r + Math.pow(2, 8)*ReadByte(data, position);
  r = r + Math.pow(2, 16)*ReadByte(data, position);
  r = r + Math.pow(2, 24)*ReadByte(data, position);

  return r;
}
function WriteByte(data, b, position){
  data.bytes[position.numberValue] = b;
  position.numberValue = position.numberValue + 1;
}
function Write2BytesLE(data, b, position){
  data.bytes[position.numberValue] = BytesRound(b%Math.pow(2, 8));
  position.numberValue = position.numberValue + 1;
  data.bytes[position.numberValue] = Math.floor(b/Math.pow(2, 8))%Math.pow(2, 8);
  position.numberValue = position.numberValue + 1;
}
function Write4BytesLE(data, b, position){
  data.bytes[position.numberValue] = BytesRound(b%Math.pow(2, 8));
  position.numberValue = position.numberValue + 1;
  data.bytes[position.numberValue] = Math.floor(b/Math.pow(2, 8))%Math.pow(2, 8);
  position.numberValue = position.numberValue + 1;
  data.bytes[position.numberValue] = Math.floor(b/Math.pow(2, 16))%Math.pow(2, 8);
  position.numberValue = position.numberValue + 1;
  data.bytes[position.numberValue] = Math.floor(b/Math.pow(2, 24))%Math.pow(2, 8);
  position.numberValue = position.numberValue + 1;
}
function Write2BytesBE(data, b, position){
  data.bytes[position.numberValue] = Math.floor(b/Math.pow(2, 8))%Math.pow(2, 8);
  position.numberValue = position.numberValue + 1;
  data.bytes[position.numberValue] = BytesRound(b%Math.pow(2, 8));
  position.numberValue = position.numberValue + 1;
}
function Write4BytesBE(data, b, position){
  data.bytes[position.numberValue] = Math.floor(b/Math.pow(2, 24))%Math.pow(2, 8);
  position.numberValue = position.numberValue + 1;
  data.bytes[position.numberValue] = Math.floor(b/Math.pow(2, 16))%Math.pow(2, 8);
  position.numberValue = position.numberValue + 1;
  data.bytes[position.numberValue] = Math.floor(b/Math.pow(2, 8))%Math.pow(2, 8);
  position.numberValue = position.numberValue + 1;
  data.bytes[position.numberValue] = BytesRound(b%Math.pow(2, 8));
  position.numberValue = position.numberValue + 1;
}
function WriteStringBytes(data, cs, position){
  var i, v;

  for(i = 0; i < cs.length; i = i + 1){
    v = cs[i].charCodeAt(0);
    WriteByte(data, v, position);
  }
}
function BytesRound(x){
  return Math.floor(x + 0.5);
}
function ByteArrayToNumberArray(src){
  var dst;
  var i, len;

  len = src.bytes.length;
  dst = [];
  dst.length = len;
  for(i = 0; i < len; i = i + 1){
    dst[i] = src.bytes[i];
  }

  return dst;
}
function NumberArrayToByteArray(src){
  var dst;
  var i, len;

  len = src.length;
  dst = {};
  dst.bytes = [];
  dst.bytes.length = len;
  for(i = 0; i < len; i = i + 1){
    dst.bytes[i] = src[i];
  }

  return dst;
}
function ByteArraysEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.bytes.length == b.bytes.length){
    for(i = 0; i < a.bytes.length && equal; i = i + 1){
      if(a.bytes[i] != b.bytes[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function CopyByteArray(a){
  var i;
  var n;

  n = {};
  n.bytes = [];
  n.bytes.length = a.bytes.length;

  for(i = 0; i < a.bytes.length; i = i + 1){
    n.bytes[i] = a.bytes[i];
  }

  return n;
}
function ByteArrayLength(response){
  return response.bytes.length;
}
function CreateAndFillByteArray(lengthx, value){
  var bytes;
  var i;

  bytes = {};
  bytes.bytes = [];
  bytes.bytes.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    bytes.bytes[i] = value;
  }

  return bytes;
}
function CreateByteArray(lengthx){
  var bytes;

  bytes = {};
  bytes.bytes = [];
  bytes.bytes.length = lengthx;

  return bytes;
}
function SetByte(array, index, value){
  array.bytes[index] = value;
}
function GetByte(array, index){
  return array.bytes[index];
}
function AssertByteArraysEqual(a, b, failures){
  var i;

  if(a.bytes.length == b.bytes.length){
    for(i = 0; i < a.bytes.length; i = i + 1){
      if(GetByte(a, i) != GetByte(b, i)){
        failures.numberValue = failures.numberValue + 1;
      }
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function FreeByteArray(byteArray){
  delete(byteArray.bytes);
  delete(byteArray);
}
function CopyByteArrayRange(a, from, to, b){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.bytes.length && to >= 0 && to <= a.bytes.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a.bytes[from + i];
    }

    b.bytes = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function BytesToTextBase16(bytes){
  var comb;
  var i, v;
  var r;

  r = [];
  r.length = bytes.bytes.length*2;
  comb = GenerateBase16ByteCombinations();

  for(i = 0; i < bytes.bytes.length; i = i + 1){
    v = bytes.bytes[i];
    r[2*i + 0] = comb[v].string[0];
    r[2*i + 1] = comb[v].string[1];
  }

  FreeBase64ByteCombinations(comb);

  return r;
}
function TextToBytesBase16WithCheck(string, bytes, message){
  var comb;
  var i, n, c, d;
  var reverseBase16;
  var codes;
  var success;

  codes = "0123456789ABCDEF".split('');

  reverseBase16 = [];
  reverseBase16.length = 128;
  for(i = 0; i < codes.length; i = i + 1){
    n = codes[i].charCodeAt(0);
    reverseBase16[n] = i;
  }

  if(string.length%2 == 0){
    bytes.bytes = CreateByteArray(string.length/2);
    comb = GenerateBase16ByteCombinations();

    success = true;
    for(i = 0; i < string.length/2 && success; i = i + 1){
      c = string[2*i + 0].charCodeAt(0);
      d = string[2*i + 1].charCodeAt(0);

      if(c == 'a'.charCodeAt(0)){
        c = 'A'.charCodeAt(0);
      }
      if(c == 'b'.charCodeAt(0)){
        c = 'B'.charCodeAt(0);
      }
      if(c == 'c'.charCodeAt(0)){
        c = 'C'.charCodeAt(0);
      }
      if(c == 'd'.charCodeAt(0)){
        c = 'D'.charCodeAt(0);
      }
      if(c == 'e'.charCodeAt(0)){
        c = 'E'.charCodeAt(0);
      }
      if(c == 'f'.charCodeAt(0)){
        c = 'F'.charCodeAt(0);
      }

      if(d == 'a'.charCodeAt(0)){
        d = 'A'.charCodeAt(0);
      }
      if(d == 'b'.charCodeAt(0)){
        d = 'B'.charCodeAt(0);
      }
      if(d == 'c'.charCodeAt(0)){
        d = 'C'.charCodeAt(0);
      }
      if(d == 'd'.charCodeAt(0)){
        d = 'D'.charCodeAt(0);
      }
      if(d == 'e'.charCodeAt(0)){
        d = 'E'.charCodeAt(0);
      }
      if(d == 'f'.charCodeAt(0)){
        d = 'F'.charCodeAt(0);
      }

      success = true;
      success = success && (c == '0'.charCodeAt(0) || c == '1'.charCodeAt(0) || c == '2'.charCodeAt(0) || c == '3'.charCodeAt(0) || c == '4'.charCodeAt(0) || c == '5'.charCodeAt(0) || c == '6'.charCodeAt(0) || c == '7'.charCodeAt(0) || c == '8'.charCodeAt(0) || c == '9'.charCodeAt(0) || c == 'A'.charCodeAt(0) || c == 'B'.charCodeAt(0) || c == 'C'.charCodeAt(0) || c == 'D'.charCodeAt(0) || c == 'E'.charCodeAt(0) || c == 'F'.charCodeAt(0));
      success = success && (d == '0'.charCodeAt(0) || d == '1'.charCodeAt(0) || d == '2'.charCodeAt(0) || d == '3'.charCodeAt(0) || d == '4'.charCodeAt(0) || d == '5'.charCodeAt(0) || d == '6'.charCodeAt(0) || d == '7'.charCodeAt(0) || d == '8'.charCodeAt(0) || d == '9'.charCodeAt(0) || d == 'A'.charCodeAt(0) || d == 'B'.charCodeAt(0) || d == 'C'.charCodeAt(0) || d == 'D'.charCodeAt(0) || d == 'E'.charCodeAt(0) || d == 'F'.charCodeAt(0));

      if(success){
        n = reverseBase16[c]*16 + reverseBase16[d];

        bytes.bytes.bytes[i] = n;
      }else{
        success = false;
        message.string = "Hex-string can only contain 0-9, A-F or a-f.".split('');
      }
    }

    FreeBase64ByteCombinations(comb);
  }else{
    bytes.bytes = CreateByteArray(0);
    success = false;
    message.string = "Hex-string must be an even number of characters.".split('');
  }

  delete(reverseBase16);

  return success;
}
function TextToBytesBase16(string){
  var comb;
  var i, n, c, d;
  var r;
  var reverseBase16;
  var codes;

  codes = "0123456789ABCDEF".split('');

  reverseBase16 = [];
  reverseBase16.length = 128;
  for(i = 0; i < codes.length; i = i + 1){
    n = codes[i].charCodeAt(0);
    reverseBase16[n] = i;
  }

  if(string.length%2 == 0){
    r = CreateByteArray(string.length/2);
    comb = GenerateBase16ByteCombinations();

    for(i = 0; i < string.length/2; i = i + 1){
      c = string[2*i + 0].charCodeAt(0);
      d = string[2*i + 1].charCodeAt(0);

      n = reverseBase16[c]*16 + reverseBase16[d];

      r.bytes[i] = n;
    }

    FreeBase64ByteCombinations(comb);
  }else{
    r = CreateByteArray(0);
  }

  delete(reverseBase16);

  return r;
}
function FreeBase64ByteCombinations(comb){
  var i;
  for(i = 0; i < 256; i = i + 1){
    FreeStringReference(comb[i]);
  }
  delete(comb);
}
function GenerateBase16ByteCombinations(){
  var comb;
  var codes;
  var i, j;
  comb = [];
  comb.length = 256;

  codes = "0123456789ABCDEF".split('');

  for(i = 0; i < 256; i = i + 1){
    comb[i] = {};
    comb[i].string = [];
    comb[i].string.length = 2;
  }

  for(j = 0; j < 16; j = j + 1){
    for(i = 0; i < 16; i = i + 1){
      comb[j*16 + i].string[1] = codes[i];
      comb[j*16 + i].string[0] = codes[j];
    }
  }

  return comb;
}
function test(){
  var x;
  var chars;

  x = CreateByteArray(3);
  x.bytes[0] = 0;
  x.bytes[1] = 255;
  x.bytes[2] = 127;

  chars = BytesToTextBase16(x);

  x = TextToBytesBase16(chars);

  return 0;
}
function CreateBooleanReference(value){
  var ref;

  ref = {};
  ref.booleanValue = value;

  return ref;
}
function CreateBooleanArrayReference(value){
  var ref;

  ref = {};
  ref.booleanArray = value;

  return ref;
}
function CreateBooleanArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.booleanArray = [];
  ref.booleanArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.booleanArray[i] = value;
  }

  return ref;
}
function FreeBooleanArrayReference(booleanArrayReference){
  delete(booleanArrayReference.booleanArray);
  delete(booleanArrayReference);
}
function CreateCharacterReference(value){
  var ref;

  ref = {};
  ref.characterValue = value;

  return ref;
}
function CreateNumberReference(value){
  var ref;

  ref = {};
  ref.numberValue = value;

  return ref;
}
function CreateNumberArrayReference(value){
  var ref;

  ref = {};
  ref.numberArray = value;

  return ref;
}
function CreateNumberArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.numberArray = [];
  ref.numberArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.numberArray[i] = value;
  }

  return ref;
}
function FreeNumberArrayReference(numberArrayReference){
  delete(numberArrayReference.numberArray);
  delete(numberArrayReference);
}
function CreateStringReference(value){
  var ref;

  ref = {};
  ref.string = value;

  return ref;
}
function CreateStringReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.string = [];
  ref.string.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.string[i] = value;
  }

  return ref;
}
function FreeStringReference(stringReference){
  delete(stringReference.string);
  delete(stringReference);
}
function CreateStringArrayReference(strings){
  var ref;

  ref = {};
  ref.stringArray = strings;

  return ref;
}
function CreateStringArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.stringArray = [];
  ref.stringArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.stringArray[i] = CreateStringReference(value);
  }

  return ref;
}
function FreeStringArrayReference(stringArrayReference){
  var i;

  for(i = 0; i < stringArrayReference.stringArray.length; i = i + 1){
    delete(stringArrayReference.stringArray[i]);
  }
  delete(stringArrayReference.stringArray);
  delete(stringArrayReference);
}


module.exports = {
	ReadXbytes: ReadXbytes,
	Read4bytesBE: Read4bytesBE,
	Read2bytesBE: Read2bytesBE,
	ReadByte: ReadByte,
	Read4bytesLE: Read4bytesLE,
	WriteByte: WriteByte,
	Write2BytesLE: Write2BytesLE,
	Write4BytesLE: Write4BytesLE,
	Write2BytesBE: Write2BytesBE,
	Write4BytesBE: Write4BytesBE,
	WriteStringBytes: WriteStringBytes,
	BytesRound: BytesRound,
	ByteArrayToNumberArray: ByteArrayToNumberArray,
	NumberArrayToByteArray: NumberArrayToByteArray,
	ByteArraysEqual: ByteArraysEqual,
	CopyByteArray: CopyByteArray,
	ByteArrayLength: ByteArrayLength,
	CreateAndFillByteArray: CreateAndFillByteArray,
	CreateByteArray: CreateByteArray,
	SetByte: SetByte,
	GetByte: GetByte,
	AssertByteArraysEqual: AssertByteArraysEqual,
	FreeByteArray: FreeByteArray,
	CopyByteArrayRange: CopyByteArrayRange,
	BytesToTextBase16: BytesToTextBase16,
	TextToBytesBase16WithCheck: TextToBytesBase16WithCheck,
	TextToBytesBase16: TextToBytesBase16,
	FreeBase64ByteCombinations: FreeBase64ByteCombinations,
	GenerateBase16ByteCombinations: GenerateBase16ByteCombinations,
	CreateBooleanReference: CreateBooleanReference,
	CreateBooleanArrayReference: CreateBooleanArrayReference,
	CreateBooleanArrayReferenceLengthValue: CreateBooleanArrayReferenceLengthValue,
	FreeBooleanArrayReference: FreeBooleanArrayReference,
	CreateCharacterReference: CreateCharacterReference,
	CreateNumberReference: CreateNumberReference,
	CreateNumberArrayReference: CreateNumberArrayReference,
	CreateNumberArrayReferenceLengthValue: CreateNumberArrayReferenceLengthValue,
	FreeNumberArrayReference: FreeNumberArrayReference,
	CreateStringReference: CreateStringReference,
	CreateStringReferenceLengthValue: CreateStringReferenceLengthValue,
	FreeStringReference: FreeStringReference,
	CreateStringArrayReference: CreateStringArrayReference,
	CreateStringArrayReferenceLengthValue: CreateStringArrayReferenceLengthValue,
	FreeStringArrayReference: FreeStringArrayReference,
	test: test
};